/*
** CALLER_ID.C
**
** Este programa lista los numeros de telefono
** desde los que se conecta cada usuario, sin
** eliminar duplicados, etc. Eso se hace con
** un script externo.
**
**
** Jesus Cea Avion
** jcea@argo.es
** http://www.argo.es/~jcea/
** http://www.argo.es/~jcea/artic/radius02.htm
**
** Lea las condiciones de uso y distribucion
** en el fichero "COPYING".
**
**
** 13/Oct/98 Version 1.0
**           Primera version publica.
**
** 18/Nov/98 Los terminadores se cambian de "" a NULL.
*/

#include <stdio.h>
#include <stdlib.h>
#include "lee_log.h"
#include "lee_radius.h"
#include "conexiones.h"
#include "version.h"

/*
** Necesarios para poder enlazar, pero no se utilizan
*/
char *RED[]={NULL};
char *CLAVE=NULL;
char *D_HISTORICO=NULL;

/* STUBS para rutinas de lectura de registros */

static t_log RADIUS = {
  abre_log_detalle_radius,
  cierra_log_detalle_radius,
  lee_registro_detalle_radius
};

log_estado lee_registro_detalle_radius_iplus(registro_log *registro)
{
log_estado estado;

  estado=lee_registro_detalle_radius(registro);
  if(registro->caller_id[0]=='\0') strcpy(registro->caller_id,"Infovia Plus");
  return estado;
}

static t_log RADIUS_IPLUS = {
  abre_log_detalle_radius,
  cierra_log_detalle_radius,
  lee_registro_detalle_radius_iplus
};



/*
** Ficheros de detalle del RADIUS.
** El final se marca con una cadena vacia.
*/

#define ISP  "@PON_TU_CPI_SI_TIENES_ALIAS"

t_accounting accounting[]={
  {"/var/adm/radacct/172.16.192.1/detalle",ISP,&RADIUS   /* Madrid */    },
  {"/var/adm/radacct/172.16.193.1/detalle",ISP,&RADIUS   /* Barcelona */ },
  {"/var/adm/radacct/172.16.192.33/detalle",ISP,&RADIUS  /* Valencia */  },
  {"/var/adm/radacct/172.16.192.49/detalle",ISP,&RADIUS  /* Bilbao */    },
  {"/var/adm/radacct/172.16.192.65/detalle",ISP,&RADIUS  /* Sevilla */   },
  {"TU_SERVIDOR_DE_TUNELES",ISP,&RADIUS_IPLUS   /* Tuneles */   },
  {NULL,NULL,NULL}}; /* Marcador final */


int main(int argc,char *argv[],char *env[]) {
log_estado estado;
registro_log reg;
int cont;

  printf("%s",version_txt());

  for(cont=0;accounting[cont].path!=NULL;cont++) {
    accounting[cont].log->abre_log(accounting[cont].path,"");
    while(!0) {
      estado=accounting[cont].log->lee_registro(&reg);
      if(estado!=LOG_OK) break;
      printf("%s %s\n",reg.nombre,reg.caller_id);
    }
    accounting[cont].log->cierra_log();
  }
  return 0;
}

